#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,float *B8,int N){
for(int i=0;i<N;i++){
A0[i] = A0[i]+A0[i];
B0[i] = B7[i]-B8[i];
B1[i] = B7[i]-B6[i];
B2[i] = B6[i];
B3[i] = B6[i]-B7[i]/B6[i];
B4[i] = B8[i]-B8[i];
B5[i] = B6[i]+B7[i];
}
}

int main(int argc,char **argv) {
int size=941766;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
float *B7;
B7 = (float *)malloc(floatBytes);
float *B8;
B8 = (float *)malloc(floatBytes);
for(int i=0;i<941766;i++){
A0[i] = 11+i+1;
B0[i] = 46.4607364576+i+1;
B1[i] = 94.9014773763+i+1;
B2[i] = 68.0734684476+i+1;
B3[i] = 82.8023745174+i+1;
B4[i] = 84.4386828419+i+1;
B5[i] = 50.4631270378+i+1;
B6[i] = 34.4552099614*i+1;
B7[i] = 71.0103891606*i+1;
B8[i] = 12.8689813398+i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,B0,B1,B2,B3,B4,B5,B6,B7,B8,941766);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
free(B5);
free(B6);
free(B7);
free(B8);
printf("\n");return 0; }